diff -c /sys/src/9/port/chan.c ./chan.c
/sys/src/9/port/chan.c:256,261 - ./chan.c:256,264
  	c->path = 0;
  	c->ismtpt = 0;
  	
+ 	c->imtpt.chan = nil;
+ 	c->imtpt.pgrp = nil;
+ 
  	return c;
  }
  
/sys/src/9/port/chan.c:310,318 - ./chan.c:313,324
  	pp->malen = p->malen;
  	pp->mtpt = smalloc(p->malen*sizeof pp->mtpt[0]);
  	for(i=0; i<pp->mlen; i++){
- 		pp->mtpt[i] = p->mtpt[i];
- 		if(pp->mtpt[i])
- 			incref(pp->mtpt[i]);
+ 		pp->mtpt[i].chan = p->mtpt[i].chan;
+ 		pp->mtpt[i].pgrp = p->mtpt[i].pgrp;
+ 		if(pp->mtpt[i].chan)
+ 			incref(pp->mtpt[i].chan);
+ 		if(pp->mtpt[i].pgrp)
+ 			incref(pp->mtpt[i].pgrp);
  	}
  
  	return pp;
/sys/src/9/port/chan.c:328,334 - ./chan.c:334,340
  //XXX
  	DBG("pathclose %p %s ref=%ld =>", p, p->s, p->ref);
  	for(i=0; i<p->mlen; i++)
- 		DBG(" %p", p->mtpt[i]);
+ 		DBG(" %p", p->mtpt[i].chan);
  	DBG("\n");
  
  	if(decref(p))
/sys/src/9/port/chan.c:335,343 - ./chan.c:341,352
  		return;
  	decref(&npath);
  	free(p->s);
- 	for(i=0; i<p->mlen; i++)
- 		if(p->mtpt[i])
- 			cclose(p->mtpt[i]);
+ 	for(i=0; i<p->mlen; i++){
+ 		if(p->mtpt[i].chan)
+ 			cclose(p->mtpt[i].chan);
+ 		if(p->mtpt[i].pgrp)
+ 			closepgrp(p->mtpt[i].pgrp);
+ 	}
  	free(p->mtpt);
  	free(p);
  }
/sys/src/9/port/chan.c:384,394 - ./chan.c:393,405
  }
  
  static Path*
- addelem(Path *p, char *s, Chan *from)
+ addelem(Path *p, char *s, Chan *from, Pgrp *pgrp)
  {
  	char *t;
  	int a, i;
- 	Chan *c, **tt;
+ 	Chan *c;
+ 	Pgrp *lpg;
+ 	struct PathElem *tt;
  
  	if(s[0]=='.' && s[1]=='\0')
  		return p;
/sys/src/9/port/chan.c:411,420 - ./chan.c:422,439
  	p->len += i;
  	if(isdotdot(s)){
  		fixdotdotname(p);
- 		DBG("addelem %s .. => rm %p\n", p->s, p->mtpt[p->mlen-1]);
- 		if(p->mlen>1 && (c = p->mtpt[--p->mlen])){
- 			p->mtpt[p->mlen] = nil;
- 			cclose(c);
+ 		DBG("addelem %s .. => rm %p\n", p->s, p->mtpt[p->mlen-1].chan);
+ 		if(p->mlen>1){
+ 			p->mlen--;
+ 
+ 			if(c = p->mtpt[p->mlen].chan){
+ 				p->mtpt[p->mlen].chan = nil;
+ 				cclose(c);
+ 			}
+ 			if(lpg = p->mtpt[p->mlen].pgrp){
+ 				p->mtpt[p->mlen].pgrp = nil;
+ 				closepgrp(lpg);
+ 			}
  		}
  	}else{
  		if(p->mlen >= p->malen){
/sys/src/9/port/chan.c:425,433 - ./chan.c:444,458
  			p->mtpt = tt;
  		}
  		DBG("addelem %s %s => add %p\n", p->s, s, from);
- 		p->mtpt[p->mlen++] = from;
+ 		p->mtpt[p->mlen].chan = from;
+ 		p->mtpt[p->mlen].pgrp = pgrp;
+ 
+ 		p->mlen++;
+ 
  		if(from)
  			incref(from);
+ 		if(pgrp)
+ 			incref(pgrp);
  	}
  	return p;
  }
/sys/src/9/port/chan.c:460,465 - ./chan.c:485,499
  		c->mchan = nil;
  	}
  
+ 	if(c->imtpt.chan != nil){
+ 		cclose(c->imtpt.chan);
+ 		c->imtpt.chan = nil;
+ 	}
+ 	if(c->imtpt.pgrp != nil){
+ 		closepgrp(c->imtpt.pgrp);
+ 		c->imtpt.pgrp = nil;
+ 	}
+ 
  	pathclose(c->path);
  	c->path = nil;
  
/sys/src/9/port/chan.c:475,481 - ./chan.c:509,519
  	if(c->flag&CFREE)
  		panic("cclose %lux", getcallerpc(&c));
  
- 	DBG("cclose %p name=%s ref=%ld\n", c, c->path->s, c->ref);
+ 	if(c->path && c->path->s)
+ 		DBG("cclose %p name=%s ref=%ld\n", c, c->path->s, c->ref);
+ 	else
+ 		DBG("cclose %p noname? ref=%ld\n", c, c->ref);
+ 
  	if(decref(c))
  		return;
  
/sys/src/9/port/chan.c:830,848 - ./chan.c:868,926
  	nc->path = c->path;
  	if(c->path)
  		incref(c->path);
+ 
+ 	nc->imtpt.chan = c->imtpt.chan;
+ 	if(c->imtpt.chan)
+ 		incref(c->imtpt.chan);
+ 	nc->imtpt.pgrp = c->imtpt.pgrp;
+ 	if(c->imtpt.pgrp)
+ 		incref(c->imtpt.pgrp);
+ 
  	return nc;
  }
  
- /* also used by sysfile.c:/^mountfix */
+ /* also used by sysfile.c:/^mountfix .
+  * Several callers depend on the semantic that ipg's refcount not be altered.
+ */
  int
- findmount(Chan **cp, Mhead **mp, int type, int dev, Qid qid)
+ findmount(Chan **cp, Mhead **mp, int type, int dev, Qid qid, Pgrp *ipg, Pgrp **opg)
  {
- 	Pgrp *pg;
  	Mhead *m;
  
- 	pg = up->pgrp;
- 	rlock(&pg->ns);
- 	for(m = MOUNTH(pg, qid); m; m = m->hash){
+ 	/* opg is an outparameter only */
+ 	assert( !opg || !(*opg) );
+ 
+ 	/* Check for override process group */
+ 	if(*cp){
+ 		/* Being told to masquerade as a channel means that that channel cannot
+ 		 * wish us to further masquerade.  It might be possible for this to be useful
+ 		 * at some later date, but for now it should be an invariant.
+ 		*/
+ 		assert( !(*cp)->imtpt.chan || 
+ 				!( (*cp)->imtpt.chan->imtpt.chan || (*cp)->imtpt.chan->imtpt.pgrp));
+ 
+ 		/* If we are given a chanel to masquerade as, override our search */
+ 		if((*cp)->imtpt.chan != nil){
+ 			type = (*cp)->imtpt.chan->type;
+ 			dev = (*cp)->imtpt.chan->dev;
+ 			qid = (*cp)->imtpt.chan->qid;
+ 		}
+ 
+ 		/* If we are given a process group in which to search, override ipg */
+ 		if((*cp)->imtpt.pgrp != nil){
+ 			/* No reference counting needed here as we do not close this
+ 			 * and we should not close the one passed in.
+ 			*/
+ 			ipg = (*cp)->imtpt.pgrp;
+ 			if(opg){
+ 				incref(ipg);
+ 				*opg = ipg;
+ 			}
+ 		}
+ 	}
+ 
+ 	rlock(&ipg->ns);
+ 	for(m = MOUNTH(ipg, qid); m; m = m->hash){
  		rlock(&m->lock);
  		if(m->from == nil){
  			print("m %p m->from 0\n", m);
/sys/src/9/port/chan.c:850,856 - ./chan.c:928,934
  			continue;
  		}
  		if(eqchantdqid(m->from, type, dev, qid, 1)){
- 			runlock(&pg->ns);
+ 			runlock(&ipg->ns);
  			if(mp != nil){
  				incref(m);
  				if(*mp != nil)
/sys/src/9/port/chan.c:862,903 - ./chan.c:940,1043
  			incref(m->mount->to);
  			*cp = m->mount->to;
  			runlock(&m->lock);
+ 
  			return 1;
  		}
  		runlock(&m->lock);
  	}
  
- 	runlock(&pg->ns);
+ 	runlock(&ipg->ns);
+ 
  	return 0;
  }
  
- /*
-  * Calls findmount but also updates path.
-  */
- static int
- domount(Chan **cp, Mhead **mp, Path **path)
+ static void
+ updatepath(Path **path, Chan *from, Pgrp *pgrp, int spg)
  {
  	Chan **lc;
+ 	Pgrp **lpg;
  	Path *p;
  
- 	if(findmount(cp, mp, (*cp)->type, (*cp)->dev, (*cp)->qid) == 0)
- 		return 0;
- 
  	if(path){
  		p = *path;
  		p = uniquepath(p);
  		if(p->mlen <= 0)
- 			print("domount: path %s has mlen==%d\n", p->s, p->mlen);
+ 			print("updatepath: path %s has mlen==%d\n", p->s, p->mlen);
  		else{
- 			lc = &p->mtpt[p->mlen-1];
- DBG("domount %p %s => add %p (was %p)\n", p, p->s, (*mp)->from, p->mtpt[p->mlen-1]);
- 			incref((*mp)->from);
+ 			lc = &p->mtpt[p->mlen-1].chan;
+ 			lpg = &p->mtpt[p->mlen-1].pgrp;
+ DBG("updatepath %p %s => add %p (was %p)\n", p, p->s, from, p->mtpt[p->mlen-1].chan);
+ 			incref(from);
  			if(*lc)
  				cclose(*lc);
- 			*lc = (*mp)->from;
+ 			if(*lpg)
+ 				closepgrp(*lpg);
+ 			*lc = from;
+ 
+ 			if(spg){
+ 				*lpg = pgrp;
+ 				incref(pgrp);
+ 			}else{
+ 				*lpg = nil;
+ 			}
  		}
  		*path = p;
  	}
+ }
+ 
+ /*
+  * Calls findmount but also updates path.
+  */
+ static int
+ domount(Chan **cp, Mhead **mp, Path **path, Pgrp *ipg, Pgrp **opg, int spg)
+ {
+ 	/* opg is an outparameter only */
+ 	assert( !opg || !(*opg) );
+ 
+ 	if(*cp && ((*cp)->imtpt.chan || (*cp)->imtpt.pgrp)){
+ 		int ret;
+ 		Chan *lc;
+ 
+ 		DBG("domount override on %p of %p in %p\n", *cp, (*cp)->imtpt.chan, (*cp)->imtpt.pgrp);
+ 
+ 		lc = (*cp)->imtpt.chan;
+ 		if(!lc)
+ 			lc = *cp;
+ 		incref(lc);
+ 
+ 		/* Do not alter ipg or imtpt.pgrp reference counts, as findmount doesn't. */
+ 		if((*cp)->imtpt.pgrp){
+ 			ipg = (*cp)->imtpt.pgrp;
+ 		}
+ 
+ 		/* Same assert as in :/^findmount */
+ 		assert( !(*cp)->imtpt.chan || 
+ 				!( (*cp)->imtpt.chan->imtpt.chan || (*cp)->imtpt.chan->imtpt.pgrp));
+ 
+ 		ret = findmount(&lc, mp, lc->type, lc->dev, lc->qid, ipg, opg);
+ 
+ 		if((*cp)->imtpt.pgrp && opg && !*opg){
+ 			/* If findmount didn't set an opg, set this one */
+ 			*opg = (*cp)->imtpt.pgrp;
+ 			incref(*opg);
+ 		}
+ 
+ 		if(ret != 0){
+ 			updatepath(path, *cp, ipg, spg);
+ 			cclose(*cp);
+ 			*cp = lc;
+ 		}else{
+ 			cclose(lc);
+ 		}
+ 
+ 		return ret;
+ 	}
+ 
+ 	if(findmount(cp, mp, (*cp)->type, (*cp)->dev, (*cp)->qid, ipg, opg) == 0)
+ 		return 0;
+ 
+ 	updatepath(path, (*mp)->from, ipg, spg);
+ 
  	return 1;
  }
  
/sys/src/9/port/chan.c:906,927 - ./chan.c:1046,1081
   * Changes name to reflect the fact that we've uncrossed the mountpoint,
   * so name had better be ours to change!
   */
- static Chan*
- undomount(Chan *c, Path *path)
+ static void
+ undomount(Path *path, Chan **c, Pgrp **pg)
  {
- 	Chan *nc;
+ 	Chan **lc;
+ 	Pgrp **lpg;
  
  	if(path->ref != 1 || path->mlen == 0)
  		print("undomount: path %s ref %ld mlen %d caller %lux\n",
  			path->s, path->ref, path->mlen, getcallerpc(&c));
  
- 	if(path->mlen>0 && (nc=path->mtpt[path->mlen-1]) != nil){
- DBG("undomount %p %s => remove %p\n", path, path->s, nc);
- 		cclose(c);
- 		path->mtpt[path->mlen-1] = nil;
- 		c = nc;
+ 	if(path->mlen>0){
+ 		lc=&path->mtpt[path->mlen-1].chan;
+ 		lpg=&path->mtpt[path->mlen-1].pgrp;
+ DBG("undomount %p %s => remove %p, %p\n", path, path->s, *lc, *lpg);
+ 		if(*lc != nil){
+ 			cclose(*c);
+ 			*c = *lc;
+ 			*lc = nil;
+ 		}
+ 		
+ 		/* Do _NOT_ destroy the pgrp merely when undoing a mount
+ 		 * as we do not shed the namespace crossing until we go up
+ 		 * to a previous directory.
+ 		*/
+ 		if(*lpg)
+ 			incref(*lpg);
+ 		if(*pg)
+ 			closepgrp(*pg);
+ 		*pg = *lpg;
  	}
- 	return c;
  }
  
  /*
/sys/src/9/port/chan.c:948,959 - ./chan.c:1102,1115
  walk(Chan **cp, char **names, int nnames, int nomount, int *nerror)
  {
  	int dev, dotdot, i, n, nhave, ntry, type;
- 	Chan *c, *nc, *mtpt;
+ 	Chan *c, *nc;
  	Path *path;
  	Mhead *mh, *nmh;
  	Mount *f;
  	Walkqid *wq;
  
+ 	Pgrp *pg;
+ 
  	c = *cp;
  	incref(c);
  	path = c->path;
/sys/src/9/port/chan.c:960,965 - ./chan.c:1116,1128
  	incref(path);
  	mh = nil;
  
+ 	/* Grab the last namespace given in the channel's path */
+ 	if (c->path->mlen == 0
+ 		|| !(pg = c->path->mtpt[c->path->mlen-1].pgrp)){
+ 		pg = up->pgrp;
+ 	}
+ 	incref(pg);
+ 
  	/*
  	 * While we haven't gotten all the way down the path:
  	 *    1. step through a mount point, if any
/sys/src/9/port/chan.c:974,979 - ./chan.c:1137,1143
  		if((c->qid.type&QTDIR)==0){
  			if(nerror)
  				*nerror = nhave;
+ 			closepgrp(pg);
  			pathclose(path);
  			cclose(c);
  			strcpy(up->errstr, Enotdir);
/sys/src/9/port/chan.c:996,1003 - ./chan.c:1160,1174
  			}
  		}
  
- 		if(!dotdot && !nomount)
- 			domount(&c, &mh, &path);
+ 		if(!dotdot && !nomount){
+ 			Pgrp *npg = nil;
+ 			domount(&c, &mh, &path, pg, &npg, pg != up->pgrp);
+ 			if(npg != nil){
+ 				/* Have been instructed to do a crossing here */
+ 				closepgrp(pg);
+ 				pg = npg;
+ 			}
+ 		}
  				
  		type = c->type;
  		dev = c->dev;
/sys/src/9/port/chan.c:1021,1026 - ./chan.c:1192,1198
  			if(wq == nil){
  				cclose(c);
  				pathclose(path);
+ 				closepgrp(pg);
  				if(nerror)
  					*nerror = nhave+1;
  				if(mh != nil)
/sys/src/9/port/chan.c:1031,1053 - ./chan.c:1203,1238
  
  		nmh = nil;
  		if(dotdot){
+ 			Pgrp *npg = nil;
+ 
  			assert(wq->nqid == 1);
  			assert(wq->clone != nil);
  
- 			path = addelem(path, "..", nil);
- 			nc = undomount(wq->clone, path);
+ 			path = addelem(path, "..", nil, nil);
+ 			nc = wq->clone;
+ 			undomount(path, &nc, &npg);
+ 
+ 			closepgrp(pg);
+ 			if(!npg){
+ 				pg = up->pgrp;
+ 				incref(pg);
+ 			}else{
+ 				pg = npg;
+ 			}
+ 
  			n = 1;
  		}else{
  			nc = nil;
- 			nmh = nil;
  			if(!nomount)
  				for(i=0; i<wq->nqid && i<ntry-1; i++)
- 					if(findmount(&nc, &nmh, type, dev, wq->qid[i]))
+ 					if(findmount(&nc, &nmh, type, dev, wq->qid[i], 
+ 						pg, nil))
  						break;
  			if(nc == nil){	/* no mount points along path */
  				if(wq->clone == nil){
  					cclose(c);
  					pathclose(path);
+ 					closepgrp(pg);
  					if(wq->nqid==0 || (wq->qid[wq->nqid-1].type&QTDIR)){
  						if(nerror)
  							*nerror = nhave+wq->nqid+1;
/sys/src/9/port/chan.c:1071,1082 - ./chan.c:1256,1268
  				}
  				n = i+1;
  			}
- 			for(i=0; i<n; i++){
- 				mtpt = nil;
- 				if(i==n-1 && nmh)
- 					mtpt = nmh->from;
- 				path = addelem(path, names[nhave+i], mtpt);
+ 			for(i=0; i<n-1; i++){
+ 				path = addelem(path, names[nhave+i], nil, 
+ 					pg == up->pgrp ? nil : pg);
  			}
+ 			path = addelem(path, names[nhave+i],
+ 							nmh ? nmh->from : nil,
+ 							pg == up->pgrp ? nil : pg);
  		}
  		cclose(c);
  		c = nc;
/sys/src/9/port/chan.c:1087,1092 - ./chan.c:1273,1280
  
  	putmhead(mh);
  
+ 	closepgrp(pg);
+ 
  	c = cunique(c);
  
  	if(c->umh != nil){	//BUG
/sys/src/9/port/chan.c:1423,1432 - ./chan.c:1611,1634
  
  	switch(amode){
  	case Abind:
- 		/* no need to maintain path - cannot dotdot an Abind */
+ 		/* no need to maintain path - cannot dotdot an Abind; further,
+ 		 * do not allow any alteration of the current namespace
+ 		*/
  		m = nil;
- 		if(!nomount)
- 			domount(&c, &m, nil);
+ 		if(!nomount){
+ 			Pgrp *npg;
+ 			int iscrossed;
+ 			if(c->path && c->path->mtpt[c->path->mlen-1].pgrp){
+ 				npg = c->path->mtpt[c->path->mlen-1].pgrp;
+ 				iscrossed = 1;
+ 			}else{
+ 				npg = up->pgrp;
+ 				iscrossed = 0;
+ 			}
+ 			incref(npg);
+ 			domount(&c, &m, nil, npg, nil, iscrossed);
+ 			closepgrp(npg);
+ 		}
  		if(c->umh != nil)
  			putmhead(c->umh);
  		c->umh = m;
/sys/src/9/port/chan.c:1440,1448 - ./chan.c:1642,1662
  		path = c->path;
  		incref(path);
  		m = nil;
- 		if(!nomount)
- 			domount(&c, &m, &path);
- 
+ 		if(!nomount){
+ 			Pgrp *npg;
+ 			int iscrossed;
+ 			if(c->path && c->path->mtpt[c->path->mlen-1].pgrp){
+ 				npg = c->path->mtpt[c->path->mlen-1].pgrp;
+ 				iscrossed = 1;
+ 			}else{
+ 				npg = up->pgrp;
+ 				iscrossed = 0;
+ 			}
+ 			incref(npg);
+ 			domount(&c, &m, &path, npg, nil, iscrossed);
+ 			closepgrp(npg);
+ 		}
+ 			
  		/* our own copy to open or remove */
  		c = cunique(c);
  
/sys/src/9/port/chan.c:1563,1569 - ./chan.c:1777,1794
  		m = nil;
  		cnew = nil;	/* is this assignment necessary? */
  		if(!waserror()){	/* try create */
- 			if(!nomount && findmount(&cnew, &m, c->type, c->dev, c->qid))
+ 			Pgrp *npg;
+ 
+ 			/* findmount doesn't alter the refcount of ipg, so we can
+ 			 * borrow these extant references without fear.
+ 			*/
+ 			if(c->path && c->path->mtpt[c->path->mlen-1].pgrp){
+ 				npg = c->path->mtpt[c->path->mlen-1].pgrp;
+ 			}else{
+ 				npg = up->pgrp;
+ 			}
+ 
+ 			if(!nomount && findmount(&cnew, &m, c->type, c->dev, c->qid, npg, nil))
  				cnew = createdir(cnew, m);
  			else{
  				cnew = c;
/sys/src/9/port/chan.c:1591,1597 - ./chan.c:1816,1822
  				putmhead(m);
  			cclose(c);
  			c = cnew;
- 			c->path = addelem(c->path, e.elems[e.nelems-1], nil);
+ 			c->path = addelem(c->path, e.elems[e.nelems-1], nil, nil);
  			break;
  		}
  
diff -c /sys/src/9/port/devproc.c ./devproc.c
/sys/src/9/port/devproc.c:16,21 - ./devproc.c:16,22
  	Qargs,
  	Qctl,
  	Qfd,
+ 	Qfd2,
  	Qfpregs,
  	Qkregs,
  	Qmem,
/sys/src/9/port/devproc.c:23,28 - ./devproc.c:24,30
  	Qnoteid,
  	Qnotepg,
  	Qns,
+ 	Qnsmnt,
  	Qproc,
  	Qregs,
  	Qsegment,
/sys/src/9/port/devproc.c:81,86 - ./devproc.c:83,89
  	"args",		{Qargs},	0,			0660,
  	"ctl",		{Qctl},		0,			0000,
  	"fd",		{Qfd},		0,			0444,
+ 	"fddbg",	{Qfd2},		0,			0444,
  	"fpregs",	{Qfpregs},	sizeof(FPsave),		0000,
  	"kregs",	{Qkregs},	sizeof(Ureg),		0400,
  	"mem",		{Qmem},		0,			0000,
/sys/src/9/port/devproc.c:88,93 - ./devproc.c:91,97
  	"noteid",	{Qnoteid},	0,			0664,
  	"notepg",	{Qnotepg},	0,			0000,
  	"ns",		{Qns},		0,			0444,
+ 	"nsmnt",	{Qnsmnt},		0,			0555 | DMDIR,
  	"proc",		{Qproc},	0,			0400,
  	"regs",		{Qregs},	sizeof(Ureg),		0000,
  	"segment",	{Qsegment},	0,			0444,
/sys/src/9/port/devproc.c:187,192 - ./devproc.c:191,216
  	Segment *q;
  	ulong pid, path, perm, len;
  
+ 	if ( QID(c->qid) == Qnsmnt ) {
+ 		if ( s == DEVDOTDOT ) {
+ 			name = nil;
+ 			s = procindex(PID(c->qid));
+ 			if ( s < 0 ) {
+ 				/* Gross!  This will return a directory but all entries
+ 				 * in it are stale.  Further, since whatever process this
+ 				 * was is now dead, we make it owned by "none".
+ 				*/
+ 				mkqid(&qid, 1<<QSHIFT, PID(c->qid), QTDIR);
+ 				devdir(c, qid, up->genbuf, 0, "none", DMDIR|0555, dp);
+ 				return 1;
+ 			}
+ 			goto findme;
+ 		} else {
+ 			/* Return error ... this is somewhat awkward! */
+ 			return -1;
+ 		}
+ 	}
+ 
  	if(s == DEVDOTDOT){
  		mkqid(&qid, Qdir, 0, QTDIR);
  		devdir(c, qid, "#p", 0, eve, 0555, dp);
/sys/src/9/port/devproc.c:213,218 - ./devproc.c:237,243
  		else if(--s >= conf.nproc)
  			return -1;
  
+ findme:
  		p = proctab(s);
  		pid = p->pid;
  		if(pid == 0)
/sys/src/9/port/devproc.c:262,268 - ./devproc.c:287,294
  		break;
  	}
  
- 	mkqid(&qid, path|tab->qid.path, c->qid.vers, QTFILE);
+ 	mkqid(&qid, path|tab->qid.path, c->qid.vers, 
+ 			(perm & DMDIR) ? QTDIR : QTFILE);
  	devdir(c, qid, tab->name, len, p->user, perm, dp);
  	return 1;
  }
/sys/src/9/port/devproc.c:303,309 - ./devproc.c:329,389
  static Walkqid*
  procwalk(Chan *c, Chan *nc, char **name, int nname)
  {
- 	return devwalk(c, nc, name, nname, 0, 0, procgen);
+ 	Walkqid *wq;
+ 	wq = devwalk(c, nc, name, nname, 0, 0, procgen);
+ 
+ 	if(!wq)
+ 		return nil;
+ 
+ 	if(wq->nqid != 0 && QID(wq->qid[wq->nqid - 1]) == Qnsmnt){
+ 		Proc *p;
+ 
+ 		if(up->pgrp->noattach){
+ 			/* Return an empty directory for unworthy clients */
+ 			print("Pid %ld is noattach but hunting in /proc\n", up->pid);
+ 			return wq;
+ 		}
+ 
+ 		if(wq->clone == nil){
+ 			/* Hoo boy; we need to get a handle on the real Qnsmnt
+ 			 * directory to return as wq->clone...
+ 			*/
+ 			Walkqid *wq2;
+ 			wq2 = devwalk(c, nil, name, wq->nqid, 0, 0, procgen);
+ 			wq->clone = wq2->clone;
+ 			free(wq2);
+ 		}
+ 		assert(wq->clone);
+ 
+ 		/* Find this process's procslot, lock the debugging mutex,
+ 		 * check to see if it's exited, if so bail out.  This code is mostly,
+ 		 * shamelessly stolen from the Qns case down in procread
+ 		*/
+ 		p=proctab(SLOT(wq->qid[wq->nqid - 1]));
+ 
+ 		qlock(&p->debug);
+ 		if(waserror()){
+ 			qunlock(&p->debug);
+ 			free(wq);
+ 			wq = nil;
+ 			nexterror();
+ 		}
+ 		if(p->pgrp == nil || p->pid != PID(wq->qid[wq->nqid - 1]))
+ 			error(Eprocdied);
+ 
+ 		/* Grab our own copy of this channel */
+ 		wq->clone = cunique(wq->clone);
+ 
+ 		incref(p->pgrp);
+ 		wq->clone->imtpt.pgrp = p->pgrp;
+ 		incref(p->slash);
+ 		wq->clone->imtpt.chan = p->slash;
+ 
+ 		qunlock(&p->debug);
+ 		poperror();
+ 	}
+ 
+ 	return wq;
  }
  
  static int
/sys/src/9/port/devproc.c:395,400 - ./devproc.c:475,481
  	case Qsegment:
  	case Qprofile:
  	case Qfd:
+ 	case Qfd2:
  		if(omode != OREAD)
  			error(Eperm);
  		break;
/sys/src/9/port/devproc.c:529,534 - ./devproc.c:610,616
  	return sprint(buf, "%lud", c->qid.vers);
  }
  
+ /* Also used by devdup, among others? */
  int
  procfdprint(Chan *c, int fd, int w, char *s, int ns)
  {
/sys/src/9/port/devproc.c:546,551 - ./devproc.c:628,683
  }
  
  static int
+ procfdprint2(Chan *c, int fd, int w, char *s, int ns)
+ {
+ 	int n, i;
+ 
+ 	if(w == 0)
+ 		w = procqidwidth(c);
+ 	n = snprint(s, ns, "%3d %.2s %C %4ld (%.16llux %*lud %.2ux) %p %p %5ld %8lld %s\n",
+ 		fd,
+ 		&"r w rw"[(c->mode&3)<<1],
+ 		devtab[c->type]->dc, c->dev,
+ 		c->qid.path, w, c->qid.vers, c->qid.type,
+ 		c, c->umh,
+ 		c->iounit, c->offset, c->path->s);
+ 	for(i = 0; i < c->path->mlen; i++){
+ 		if(c->path->mtpt[i].chan){
+ 			if(c->path->mtpt[i].chan->path){
+ 				n += snprint(s+n, ns-n,
+ 					"\t%2d %8p (%C %.16llux %*lud %.2ux) %8p %8p %8p %s\n", 
+ 					i, c->path->mtpt[i].chan,
+ 					devtab[c->path->mtpt[i].chan->type]->dc,
+ 					c->path->mtpt[i].chan->qid.path,
+ 					w, c->path->mtpt[i].chan->qid.vers, 
+ 					c->path->mtpt[i].chan->qid.type,
+ 					c->path->mtpt[i].pgrp,
+ 					c->path->mtpt[i].chan->imtpt.chan,
+ 					c->path->mtpt[i].chan->imtpt.pgrp,
+ 					c->path->mtpt[i].chan->path->s);
+ 			}else{
+ 				n += snprint(s+n, ns-n,
+ 					"\t%2d %8p (%C %.16llux %*lud %.2ux) %8p %8p %8p %s\n", 
+ 					i, c->path->mtpt[i].chan,
+ 					devtab[c->path->mtpt[i].chan->type]->dc,
+ 					c->path->mtpt[i].chan->qid.path, 
+ 					w, c->path->mtpt[i].chan->qid.vers,
+ 					c->path->mtpt[i].chan->qid.type,
+ 					c->path->mtpt[i].pgrp,
+ 					c->path->mtpt[i].chan->imtpt.chan,
+ 					c->path->mtpt[i].chan->imtpt.pgrp,
+ 					"No Path");
+ 			}
+ 		}else{
+ 				n += snprint(s+n, ns-n, "\t%2d %8p %8p %s\n", 
+ 					i, c->path->mtpt[i].chan, c->path->mtpt[i].pgrp,
+ 					"No Chan");
+ 		}
+ 	}
+ 	return n;
+ }
+ 
+ static int
  procfds(Proc *p, char *va, int count, long offset)
  {
  	Fgrp *f;
/sys/src/9/port/devproc.c:602,607 - ./devproc.c:734,804
  	return n;
  }
  
+ #define PROCFDS2_BUF_SIZE 2048
+ 
+ static int
+ procfds2(Proc *p, char *va, int count, long offset)
+ {
+ 	Fgrp *f;
+ 	Chan *c;
+ 	char *buf;
+ 	int n, i, w, ww;
+ 	char *a;
+ 
+ 	buf = malloc(PROCFDS2_BUF_SIZE);
+ 
+ 	/* print to buf to avoid holding fgrp lock while writing to user space */
+ 	if(count > PROCFDS2_BUF_SIZE)
+ 		count = PROCFDS2_BUF_SIZE;
+ 	a = buf;
+ 
+ 	qlock(&p->debug);
+ 	f = p->fgrp;
+ 	if(f == nil){
+ 		qunlock(&p->debug);
+ 		return 0;
+ 	}
+ 	lock(f);
+ 	if(waserror()){
+ 		unlock(f);
+ 		qunlock(&p->debug);
+ 		free(buf);
+ 		nexterror();
+ 	}
+ 
+ 	n = readstr(0, a, count, p->dot->path->s);
+ 	n += snprint(a+n, count-n, "\n");
+ 	offset = procoffset(offset, a, &n);
+ 	/* compute width of qid.vers */
+ 	w = 0;
+ 	for(i = 0; i <= f->maxfd; i++) {
+ 		c = f->fd[i];
+ 		if(c == nil)
+ 			continue;
+ 		ww = procqidwidth(c);
+ 		if(ww > w)
+ 			w = ww;
+ 	}
+ 	n += procfdprint2(p->dot, -1, w, a+n, count-n);
+ 	for(i = 0; i <= f->maxfd; i++) {
+ 		c = f->fd[i];
+ 		if(c == nil)
+ 			continue;
+ 		n += procfdprint2(c, i, w, a+n, count-n);
+ 		offset = procoffset(offset, a, &n);
+ 	}
+ 	unlock(f);
+ 	qunlock(&p->debug);
+ 	poperror();
+ 
+ 	/* copy result to user space, now that locks are released */
+ 	memmove(va, buf, n);
+ 
+ 	free(buf);
+ 
+ 	return n;
+ }
+ 
  static void
  procclose(Chan * c)
  {
/sys/src/9/port/devproc.c:700,708 - ./devproc.c:896,904
  			navail = n / sizeof(Traceevent);
  		while(navail > 0) {
  			ne = ((tconsumed & Emask) + navail > Nevents)? 
- 					Nevents - (tconsumed & Emask): navail;
+ 						Nevents - (tconsumed & Emask): navail;
  			memmove(rptr, &tevents[tconsumed & Emask], 
- 					ne * sizeof(Traceevent));
+ 						ne * sizeof(Traceevent));
  
  			tconsumed += ne;
  			rptr += ne * sizeof(Traceevent);
/sys/src/9/port/devproc.c:959,964 - ./devproc.c:1155,1162
  		return readnum(offset, va, n, p->noteid, NUMSIZE);
  	case Qfd:
  		return procfds(p, va, n, offset);
+ 	case Qfd2:
+ 		return procfds2(p, va, n, offset);
  	}
  	error(Egreg);
  	return 0;		/* not reached */
diff -c /sys/src/9/port/pgrp.c ./pgrp.c
/sys/src/9/port/pgrp.c:93,99 - ./pgrp.c:93,101
  	}
  	wunlock(&p->ns);
  	qunlock(&p->debug);
- 	free(p);
+ 
+ 	if(((Ref*)p)->ref == 0)
+ 		free(p);
  }
  
  void
diff -c /sys/src/9/port/portdat.h ./portdat.h
/sys/src/9/port/portdat.h:148,153 - ./portdat.h:148,159
  #define BLEN(s)	((s)->wp - (s)->rp)
  #define BALLOC(s) ((s)->lim - (s)->base)
  
+ struct PathElem
+ {
+ 	Chan *chan;	/* mtpt history */
+ 	Pgrp *pgrp;	/* namespace history */
+ };
+ 
  struct Chan
  {
  	Ref;				/* the Lock in this Ref is also Chan's lock */
/sys/src/9/port/portdat.h:182,187 - ./portdat.h:188,199
  	Chan*	mchan;			/* channel to mounted server */
  	Qid	mqid;			/* qid of root of mount point */
  	Path*	path;
+ 
+ 	/* Channel implicit mountpoint */
+ 	struct {
+ 		Chan *chan;
+ 		Pgrp *pgrp;
+ 	} imtpt;
  };
  
  struct Path
/sys/src/9/port/portdat.h:188,194 - ./portdat.h:200,206
  {
  	Ref;
  	char	*s;
- 	Chan	**mtpt;			/* mtpt history */
+ 	struct PathElem *mtpt;
  	int	len;			/* strlen(s) */
  	int	alen;			/* allocated length of s */
  	int	mlen;			/* number of path elements */
diff -c /sys/src/9/port/portfns.h ./portfns.h
/sys/src/9/port/portfns.h:48,53 - ./portfns.h:48,54
  void		copypage(Page*, Page*);
  void		countpagerefs(ulong*, int);
  int		cread(Chan*, uchar*, int, vlong);
+ Chan *	cunique(Chan *);
  void		cunmount(Chan*, Chan*);
  void		cupdate(Chan*, uchar*, int, vlong);
  void		cwrite(Chan*, uchar*, int, vlong);
/sys/src/9/port/portfns.h:107,113 - ./portfns.h:108,114
  int		fault(ulong, int);
  void		fdclose(int, int);
  Chan*		fdtochan(int, int, int, int);
- int		findmount(Chan**, Mhead**, int, int, Qid);
+ int		findmount(Chan**, Mhead**, int, int, Qid, Pgrp*, Pgrp **);
  int		fixfault(Segment*, ulong, int, int);
  void		flushmmu(void);
  void		forceclosefgrp(void);
diff -c /sys/src/9/port/sysfile.c ./sysfile.c
/sys/src/9/port/sysfile.c:548,553 - ./sysfile.c:548,554
  	long l;
  	uchar *buf, *e;
  	Dir d;
+ 	Pgrp *npg;
  
  	p = op;
  	buf = nil;
/sys/src/9/port/sysfile.c:558,564 - ./sysfile.c:559,575
  			break;
  		nc = nil;
  		mh = nil;
- 		if(findmount(&nc, &mh, d.type, d.dev, d.qid)){
+ 
+ 		/* findmount doesn't alter the refcount of ipg, so we can
+ 		 * borrow these extant references without fear.
+ 		*/
+ 		if(c->path && c->path->mtpt[c->path->mlen-1].pgrp){
+ 			npg = c->path->mtpt[c->path->mlen-1].pgrp;
+ 		}else{
+ 			npg = up->pgrp;
+ 		}
+ 
+ 		if(findmount(&nc, &mh, d.type, d.dev, d.qid, npg, nil)){
  			/*
  			 * If it's a union directory and the original is
  			 * in the union, don't rewrite anything.
